{ GMSStickyLabel v2 Feb/19/98  by Glenn Shukster & Jacques Scoatarin

  GMS COMPUTING INC.                 Phone         (905)771-6458
  53 COLVIN CRES.                    Fax                   -6819
  THORNHILL, ONT.                    Compuserve:       72734,123
  CANADA  L4J 2N7                    InternetId:Gms@Shaw.wave.ca
                                     http://members.tor.shaw.wave.ca/~gms/

  Jacques Scoatarin                  Phone         (357)2-492591
  52 Athalassis Ave. (flat 202)
  Nicosia
  Cyprus                             InternetId:j.scoatarin@cytanet.com.cy


Purpose:
  TLabel that will attach to any TWinControl Component on the
  form like TEdit, TDBMemo, TButton etc.  There are other
  components out there that make a label part of the edit or
  memo etc. but they tie you too much to that other component.

Features:
  1) All abilities of TLabel still exist
  2) Works with Delphi 1,2,3.
  3) _AlignTo: The position it will align to the TWinControl (left, right, top, bottom)
  4) _AttachTo: The TWincontrol this label will attach to.
  5) _Gap:     The space between the two components
  6) _AlignPos: Further positions the label on the _AlignTo side
                (TopLeft, Center, BottomRight)
  7) _AlignPosGap: The spaces from _AlignPos on the _AlignTo side
  8) Right Click: Component editor option
           realigns all TGMSStickyLabels on the form(owner) to their _AttachTo components
  9) Drop Label on any TWinControl and it asks to fill in _AttachTo with that component
  10)Move TWinControl: the label will follow the _AttachTo component

Known Problems:
   1) Changing any property that affects the visual appearance of the TWinControl will
   call RecreateWnd. For example changing CharCase.  Since the object is the same
   but the window handle is a new one, effectively there is no hook into the control's
   window procedure.
   Unfortunately there seems to be no way of re-subclassing.  The last message we get
   in the AttachedTo window subclassed function is WM_DESTROY, thus one might try to
   at least un-assign FAttachTo.
   Under normal circumstance you could call a PostMessage upon receiving WM_DESTROY and
   check if the FAttachTo is still assigned (meaning RecreateWnd was called) however
   TLabel is not a proper window control and does not have a window handle.
   Thanks to <T.M.Liaw>  tmliaw@pc.jaring.my for pointing this problem out, and
   Jacques Scoatarin for the above explanation

Files:
  GMSLabel.pas : This component
  GMSLabCE.pas : Component editor for GMSLabel
  LblEdit.pas  : old name for Component editor for GMSLabCE, delete LblEdit.pas file
  GMSLabel.dcr : In the 16 directory for Delphi 1
  GMSLabel.dcr : In the 32 directory for Delphi 2 & 3

Installation:
  Copy the above pas files and the *.dcr file in the (16 Dir Delphi1)
  or (32 Dir Delphi 2 & 3) into one of the dirs in your component lib
  search path.  Then install gmslabel.pas & lbledit.pas.
  Only GMSStickyLabel will appear on your component pallet under GMS.

Copyright:
  This component is free if you keep this comment header.
  Any damage real or imagined caused by this component is
  100% your responsibility not GMS Computing Inc.'s.

Thank You
  This free component is my way of saying thank you to The Delphi Community.
  People have been more than helpful to me in the forums & newsgroups,
  especially team B members, Wayne Niddery, and Jacques Scoatarin.
  As an example of how great a community we have within a day of sending
  this component out Jacques Scoatarin basically added the lower level api
  calls to enable features 7 & 8 which make the component much more robust.
  Enjoy!

  If you like and use this component e-mail to let me know.
  P.S. GMS Computing Inc.(which is me) is always looking for new contracts.
  If you like what you see then contact me.  See my web page for more details.

VERSION INFO
GMSStickyLabel v1.1 July/5/97  by Glenn Shukster & Jacques Scoatarin
    - Released on public.
 V 1.2  Aug/14/97
    - Thanks to Erik B. Berry <berry@elvis.rhodes.edu> &
      Jean-Christophe Boggio <cat@gestalt.freenix.fr> who reported the
      behavior below
    - Corrected weird behavior that occured when the panel was aligned
      bottom and then you assign the TGMSStickylabel
    - Corrected if TGMSStickyLabel is moved from _AttachedTo component
      back to the same _AttachedTo component it would not realign itself.
      Now it does.
    - Corrected when selecting _AttachedTo you could select a component
      who did not have the same parent with poor results:  Added a
      property editor that only displays TWinControls that have the same parent.
 V 1.3 Sep/22/97
    - Thanks to Gerald  gerald@hydra.hkstar.com for reporting the following bug
    - Bug in only Delphi3 version.  When there is something aligned to top and
      a new TGMSStickyLabel is dropped on a component it will loop through all the
      components 3 times with the RectBounds of the TGMSStickyLabel being incorrect
      until the last loop.   In Delphi2 & 1 it only goes thought the loop once with
      the correct co-ordinates.
      Solution was that only attach if (Self.BoundsRect.Top > 0)
      This is a trade off for if you ever try to drop a component at position 0 it will
      not attach.  Drop it just a bit below 0 and it will align no problem.
    - Thanks to Erik B. Berry <berry@elvis.rhodes.edu> for the below improvement
      Eric suggested to have the component alignment be laRightJustify if the _AlignTo
      is alLeft.  This way when editing the caption it will grow away from the control
      its attached to, thus not asking to attach to it again.
 V 1.4 Nov/12/97
    - Added options the following options to the property editor
      alignment (right, left, top, bottom), Set gap, Edit Caption
 V 1.5 Jan/10/98
    - Changed all Assigned(FAttachTo) to the Nil syntax eg. (FAttachTo<>Nil)
      for Delphi 3 in some cases this caused problems
    - Fixed _AttachTo so it could be blanked if needed.  Before once a TWinControl
      was assigned this property could not be empty
    - Added _Offset
    - Thanks to Mike King from London UK at <mike_king@compuserve.com> for suggesting
      this option
 V 2 Jan/27/98
    - Removed the annoying repeated question to attach to another TWinControl when
      you are moving the TWinControl with a TGMSStickylabel attached and it overlaps
      with another TWinControl.
    - Changed name from _Offset to _AlignPosGap, 1.5 was only distributed to a small few,
      thus, now was the time to change it, if you had TGMSStickylabels using _Offset it
      will blank them all to 0.
    - Changed the name of the Component Editor to GMSLabCE.pas (kept it to 8 char for
      Delphi1 compatibility) Delete the old one called LblEdit.pas
    - Added _AlignPos thanks to Erik B. Berry <berry@elvis.rhodes.edu>
}

unit GMSLabel;

{$D-} { Turns debugger off  comment this line out if you want to step through it}

interface

uses
  Classes,
  StdCtrls,
  Controls,
  Messages,
  Forms,
  Dialogs,
  DsgnIntf,
{$IFDEF WIN32}
  SysUtils, { for writing to file for debugging purposes}
  Windows
{$ELSE}
  WinProcs, WinTypes
{$ENDIF}
;

type
  TAlignTo = (alLeft, alTop, alBottom,  alRight);
  TAlignPos = (alTopLeft, alCenter, alBottomRight);
  TGMSStickyLabel = class(TLabel)
  private
    FAttachTo: TWinControl;
    FAlignTo: TAlignTo;
    FAlignPos: TAlignPos;
    FGap : Integer;
    FAlignPosGap:integer;
    FDefAttachedProc: Pointer;
    FAttachedInstance: Pointer;
    FRealigning: Boolean;
    Procedure SetGap(Value: Integer);
    procedure SetAttachTo(Value: TWinControl);
    Procedure SetAlignTo(Value: TAlignTo);
    Procedure SetAlignPosGap(Value: Integer);
    procedure SetAlignPos(Value: TAlignPos);
    { New Attached controls WndProc }
    procedure AttachedWndProc(var Message: TMessage);
    { Procedure ErrFile(sString: String);}
  protected
    procedure CheckForControl;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetParent(AParent: TWinControl); override;
    { Override WndProc }
    procedure WndProc(var Message: TMessage); override;
  public
    Procedure _ReAlign;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property _AlignTo: TAlignTo read FAlignTo write SetAlignTo default alLeft;
    property _AttachTo: TWinControl read FAttachTo write SetAttachTo;
    Property _Gap : Integer Read FGap write SetGap Default 5;
    property _AlignPos : TAlignPos Read FAlignPos write SetAlignPos Default  alCenter;
    Property _AlignPosGap: integer read FAlignPosGap write SetAlignPosGap default 4;
  end;

procedure Register;

implementation

constructor TGMSStickyLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FGap := 5;
  FAlignPosGap := 0;
  FRealigning := False;
  { Make Instance out of method }
  FAttachedInstance := MakeObjectInstance(AttachedWndProc);
end;

destructor TGMSStickyLabel.Destroy;
begin
  { Restore original Attach Control WndProc }
  {   IsWindow check may be uneccessary but doesn't hurt ti be 100% sure }
  if (FAttachTo<>Nil) and IsWindow(FAttachTo.Handle) then
    SetWindowLong(FAttachTo.Handle, GWL_WNDPROC, Longint(FDefAttachedProc));
  { Make method Instance }
  FreeObjectInstance(FAttachedInstance);
  inherited Destroy;
end;

procedure TGMSStickyLabel.AttachedWndProc(var Message: TMessage);
begin
  with Message do
  begin
    case Msg of
      { On Move/Size message call _ReAlign to keep us aligned! }
      WM_MOVE, WM_SIZE :  _ReAlign;
    end;
    Result := CallWindowProc(FDefAttachedProc, FAttachTo.Handle, Msg, WParam, LParam);
  end;
end;
procedure TGMSStickyLabel.WndProc(var Message: TMessage);
begin
  with Message do
  begin
    case Msg of
      { On change of position check for controls to attach to }
      WM_WINDOWPOSCHANGED:
        if (not FRealigning) and (csDesigning in ComponentState) then CheckForControl;
    end;
  end;
  inherited WndProc(Message);
end;

procedure TGMSStickyLabel.CheckForControl;
var
  I: Integer;
  RCDest: TRect;
begin
  { if - for not checking if already attached ? }
  with Owner do
  begin
    for I := 1 to ComponentCount do
     { self is stickylabel}
     if (Components[I - 1] is TWinControl) and (Components[I - 1] <> Self) then
       with Components[I - 1] as TWinControl do
         if (Parent = Self.Parent) then
           begin
               {
               ErrFile('Name:'+Name +'  Parent:'+ Parent.Name+ ' Self:'+Self.Name+#13 +
                 'Self.BoundsRect.Top   '+IntToStr(Self.BoundsRect.Top)+ #13 +
                 'Self.BoundsRect.Left   '+IntToStr(Self.BoundsRect.Left)+ #13 +
                 'Self.BoundsRect.Bottom'+IntToStr(Self.BoundsRect.Bottom)+ #13 +
                 'BoundsRect.Top'+IntToStr(BoundsRect.Top) + #13 +
                 'BoundsRect.Left'+IntToStr(BoundsRect.Left) + #13 +
                 'BoundsRect.Bottom'+IntToStr(BoundsRect.Bottom)
                 );
                 }
             { this was for an peculiar functionality in Delphi 3}
             If (Self.BoundsRect.Top > 0) Then
               begin
                 IntersectRect(RCDest, Self.BoundsRect, BoundsRect);
                 if not IsRectEmpty(RCDest) then
                   begin
                    {ErrFile('Asked to attach to '+Name+#13+#13);}
                    if MessageDlg('Attach label to ' + Name, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                      begin
                        _AttachTo := Owner.Components[I - 1] as TWinControl;
                        FocusControl := Owner.Components[I - 1] as TWinControl;
                      end;
                    break;
                   end;
               end;
           end;
  end;
end;

procedure TGMSStickyLabel.SetParent(AParent: TWinControl);
var
  FOrigParent: TWinControl;
begin
  FOrigParent := Parent;
  inherited SetParent(AParent);
  if (Parent <> Nil) and not (FOrigParent<>Nil) then
    CheckForControl;
end;

procedure TGMSStickyLabel.Notification(AComponent: TComponent; Operation: TOperation);
begin
  { dont forget to check if indeed it is FAttachTo that is being removed }
  if (Operation = opRemove) and (AComponent = FAttachTo) then
    FAttachTo := Nil;
  inherited Notification(AComponent,Operation);
end;

procedure TGMSStickyLabel.SetAttachTo(Value: TWinControl);
begin
  if (FAttachTo <> Value) then
  begin
    { Restore original previously Attach Control WndProc }
    {   IsWindow check may be uneccessary but doesn't hurt to be 100% sure }
    If (Value=Nil) or (FAttachTo=Nil) or ((FAttachTo<>Nil) and (Value.Parent = Self.Parent)) Then {gms}
      begin
        if (FAttachTo<>Nil) and IsWindow(FAttachTo.Handle) then
           SetWindowLong(FAttachTo.Handle, GWL_WNDPROC, Longint(FDefAttachedProc));

        FAttachTo := Value;
        if (FAttachTo<>Nil) and IsWindow(FAttachTo.Handle) then
        begin
          { Get original Attach Control WndProc }
          FDefAttachedProc := Pointer(GetWindowLong(FAttachTo.Handle, GWL_WNDPROC));
          { Set the new Attach Control WndProc - our own method! }
          SetWindowLong(FAttachTo.Handle, GWL_WNDPROC, Longint(FAttachedInstance));
          _ReAlign;
        end;
      end
    else
      if ((FAttachTo<>Nil) and (Value.Parent <> Self.Parent)) Then
         ShowMessage('Must have the same parents '+ #13#10 +
                     'AttachTo Parent is '+ TControl(Value.Parent).Name + #13#10 +
                     'TGMSStickyLabel Parent is '+ TControl(Self.Parent).Name);
  end
 else
   _ReAlign; { GMS if assigned back to the same component it will realign itself}
end;

Procedure TGMSStickyLabel.SetAlignTo(Value: TAlignTo);
begin
 If (FAlignTo <> Value) then
    begin
      FAlignTo := Value;
      _ReAlign;
    end ;
end;

Procedure TGMSStickyLabel.SetAlignPos(Value: TAlignPos);
begin
  If (FAlignPos <> Value) then
    begin
      FAlignPos := Value;
      _ReAlign;
    end;
end;

Procedure TGMSStickyLabel.SetGap(Value: Integer);
begin
  If (FGap <> Value) Then
    begin
      FGap := Value;
      _ReAlign;
    end;
end;

Procedure TGMSStickyLabel.SetAlignPosGap(Value: Integer);
begin
  If (FAlignPosGap <> Value) Then
    begin
      FAlignPosGap := Value;
      _ReAlign;
    end;
end;

Procedure TGMSStickyLabel._ReAlign;
var
  iNewTop, iNewLeft: Integer;
begin
  iNewTop := 0;  { to get rid of warnings}
  iNewLeft := 0; { to get rid of warnings}
  FRealigning := True;
  If FAttachTo <> Nil then
  begin
    Case FAlignTo of
       alLeft:
         begin
          Alignment := taRightJustify;
          case FAlignPos of
               alTopLeft: iNewTop :=  FAttachTo.Top + FAlignPosGap;
               alCenter: iNewTop :=  FAttachTo.Top + Round((FAttachTo.Height -Height)/2) + FAlignPosGap;
               alBottomRight: iNewTop :=  FAttachTo.Top + FAttachTo.Height -  Height + FAlignPosGap;
          end;
          {iNewTop :=  FAttachTo.Top + FAlignPosGap;}
          iNewLeft := FAttachTo.Left - Width - FGap ;
         end ;
       alRight:
         begin
          Alignment := taLeftJustify;
          case FAlignPos of
              alTopLeft: iNewTop :=  FAttachTo.Top + FAlignPosGap;
              alCenter: iNewTop :=  FAttachTo.Top + Round((FAttachTo.Height -Height)/2) + FAlignPosGap;
              alBottomRight: iNewTop :=  FAttachTo.Top + FAttachTo.Height -  Height  + FAlignPosGap;
           end;
          {iNewTop := FAttachTo.Top + FAlignPosGap;}
          iNewLeft := FAttachTo.Left + FAttachTo.Width + FGap ;
         end ;
       alTop:
         begin
           iNewTop := FAttachTo.Top - Height - FGap ;
           case FAlignPos of
              alTopLeft:
                 begin
                   Alignment := taLeftJustify;
                   iNewLeft := FAttachTo.Left  + FAlignPosGap;
                 end;
              alCenter:
                 begin
                   Alignment := taCenter;
                   iNewLeft := FAttachTo.Left + Round((FAttachTo.Width - Width)/2)+ FAlignPosGap;
                 end;
              alBottomRight:
                 begin
                   Alignment := taRightJustify;
                   iNewLeft := FAttachTo.Left + FAttachTo.Width - Width + FAlignPosGap;
                 end;
           end;
          {iNewTop := FAttachTo.Top - Height - FGap ;
          iNewLeft := FAttachTo.Left + FAlignPosGap;
          Alignment := taLeftJustify;}
         end;
       alBottom:
         begin
           iNewTop := FAttachTo.Top + FAttachTo.Height + FGap ;
           case FAlignPos of
              alTopLeft:
                 begin
                   Alignment := taLeftJustify;
                   iNewLeft := FAttachTo.Left + FAlignPosGap;
                 end;
              alCenter:
                 begin
                   Alignment := taCenter;
                   iNewLeft := FAttachTo.Left + Round((FAttachTo.Width - Width)/2)+ FAlignPosGap;
                 end;
              alBottomRight:
                 begin
                   Alignment := taRightJustify;
                   iNewLeft := FAttachTo.Left + FAttachTo.Width - Width + FAlignPosGap;
                 end;
           end;
          {iNewTop := FAttachTo.Top + FAttachTo.Height + FGap ;
          iNewLeft := FAttachTo.Left + FAlignPosGap;
          Alignment := taLeftJustify;}
         end;
    end;
    { Set all propertied in one call to avoid multiple re-drawing & pos changes }
    SetBounds(iNewLeft, iNewTop, Width, Height);
  end;
  FRealigning := False;
end;

(*
Procedure TGMSStickyLabel.ErrFile(sString: String);
const
  cFileName = 'c:\Event.txt';
var
  FLog: TextFile;
begin
  AssignFile(FLog, cFileName);
  if FILEEXISTS(cFileName) Then
     Append(FLog)
  else
     ReWrite(FLog);
  Writeln(FLog,sString);
  CloseFile(FLog); {Close file, save changes}
end;
  *)


{PROPERTY EDITOR}
type
    TAttachToEditor = class(TComponentProperty)
    public
      procedure GetValues(Proc: TGetStrProc); override;
    end;

procedure TAttachToEditor.GetValues(Proc: TGetStrProc);
var
  II: Integer;
  Values: TStringList;
  oGMSStickyLabel : TGMSStickyLabel;
  P,P1 : TWinControl;
begin
  Values := TStringList.Create;
  try
    oGMSStickyLabel := GetComponent(0) as TGMSStickyLabel;
    P := oGMSStickyLabel.Parent;
    for II := 0 to P.ControlCount-1 do begin
      P1 := TWinControl(P.Controls[II]);
      if (P1 is TWinControl)
        and ((P.Controls[ii] is TGMSStickyLabel) = False)
        and (P1.Name <> '') then
          Values.Add(P1.Name);
    end;
    for II := 0 to Values.Count - 1 do Proc(Values[II]);
  finally
    Values.Free;
  end;
end;

procedure Register;
begin
  RegisterComponents('GMS', [TGMSStickyLabel]);
  RegisterPropertyEditor(TypeInfo(TWinControl),TGMSStickyLabel,'_AttachTo',TAttachToEditor);
end;

end.